"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarketAccountData = exports.MarketState = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const consts_1 = require("../consts");
var MarketState;
(function (MarketState) {
    MarketState[MarketState["Uninitialized"] = 0] = "Uninitialized";
    MarketState[MarketState["Created"] = 1] = "Created";
    MarketState[MarketState["Active"] = 2] = "Active";
    MarketState[MarketState["Ended"] = 3] = "Ended";
})(MarketState = exports.MarketState || (exports.MarketState = {}));
const marketAccountDiscriminator = [219, 190, 213, 55, 0, 227, 198, 154];
class MarketAccountData {
    constructor(store, sellingResource, treasuryMint, treasuryHolder, treasuryOwner, owner, name, description, mutable, price, piecesInOneWallet, startDate, endDate, state) {
        this.store = store;
        this.sellingResource = sellingResource;
        this.treasuryMint = treasuryMint;
        this.treasuryHolder = treasuryHolder;
        this.treasuryOwner = treasuryOwner;
        this.owner = owner;
        this.name = name;
        this.description = description;
        this.mutable = mutable;
        this.price = price;
        this.piecesInOneWallet = piecesInOneWallet;
        this.startDate = startDate;
        this.endDate = endDate;
        this.state = state;
    }
    static get byteSize() {
        return marketAccountDataStruct.byteSize;
    }
    static fromArgs(args) {
        return new MarketAccountData(args.store, args.sellingResource, args.treasuryMint, args.treasuryHolder, args.treasuryOwner, args.owner, args.name, args.description, args.mutable, args.price, args.piecesInOneWallet, args.startDate, args.endDate, args.state);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return MarketAccountData.deserialize(accountInfo.data, offset);
    }
    static getMinimumBalanceForRentExemption(connection, commitment) {
        return __awaiter(this, void 0, void 0, function* () {
            return connection.getMinimumBalanceForRentExemption(MarketAccountData.byteSize, commitment);
        });
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === MarketAccountData.byteSize;
    }
    static deserialize(buf, offset = 0) {
        return marketAccountDataStruct.deserialize(buf, offset);
    }
    serialize() {
        return marketAccountDataStruct.serialize(Object.assign({ accountDiscriminator: marketAccountDiscriminator }, this));
    }
    pretty() {
        return {
            store: this.store.toBase58(),
            sellingResource: this.sellingResource.toBase58(),
            treasuryMint: this.treasuryMint.toBase58(),
            treasuryHolder: this.treasuryHolder.toBase58(),
            treasuryOwner: this.treasuryOwner.toBase58(),
            owner: this.owner.toBase58(),
            name: this.name,
            description: this.description,
            mutable: this.mutable,
            price: this.price,
            piecesInOneWallet: this.piecesInOneWallet,
            startDate: this.startDate,
            endDate: this.endDate,
        };
    }
}
exports.MarketAccountData = MarketAccountData;
const marketAccountDataStruct = new beet.BeetStruct([
    ['accountDiscriminator', beet.fixedSizeArray(beet.u8, 8)],
    ['store', beetSolana.publicKey],
    ['sellingResource', beetSolana.publicKey],
    ['treasuryMint', beetSolana.publicKey],
    ['treasuryHolder', beetSolana.publicKey],
    ['treasuryOwner', beetSolana.publicKey],
    ['owner', beetSolana.publicKey],
    ['name', beet.fixedSizeUtf8String(consts_1.NAME_MAX_LEN)],
    ['description', beet.fixedSizeUtf8String(consts_1.DESCRIPTION_MAX_LEN)],
    ['mutable', beet.bool],
    ['price', beet.u64],
    ['piecesInOneWallet', beet.coption(beet.u64)],
    ['startDate', beet.u64],
    ['endDate', beet.coption(beet.u64)],
    ['state', beet.u8],
], MarketAccountData.fromArgs, 'MarketAccountData');
//# sourceMappingURL=Market.js.map