"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SellingResourceAccountData = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const sellingResourceAccountDiscriminator = [15, 32, 69, 235, 249, 39, 18, 167];
class SellingResourceAccountData {
    constructor(store, owner, resource, vault, vaultOwner, supply, maxSupply, state) {
        this.store = store;
        this.owner = owner;
        this.resource = resource;
        this.vault = vault;
        this.vaultOwner = vaultOwner;
        this.supply = supply;
        this.maxSupply = maxSupply;
        this.state = state;
    }
    static get byteSize() {
        return sellingResourceAccountDataStruct.byteSize;
    }
    static getMinimumBalanceForRentExemption(connection, commitment) {
        return __awaiter(this, void 0, void 0, function* () {
            return connection.getMinimumBalanceForRentExemption(SellingResourceAccountData.byteSize, commitment);
        });
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === SellingResourceAccountData.byteSize;
    }
    static fromArgs(args) {
        return new SellingResourceAccountData(args.store, args.owner, args.resource, args.vault, args.vaultOwner, args.supply, args.maxSupply, args.state);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return SellingResourceAccountData.deserialize(accountInfo.data, offset);
    }
    static deserialize(buf, offset = 0) {
        return sellingResourceAccountDataStruct.deserialize(buf, offset);
    }
    serialize() {
        return sellingResourceAccountDataStruct.serialize(Object.assign({ accountDiscriminator: sellingResourceAccountDiscriminator }, this));
    }
    pretty() {
        return {
            store: this.store.toBase58(),
            owner: this.owner.toBase58(),
            resource: this.resource.toBase58(),
            vault: this.vault.toBase58(),
            vaultOwner: this.vaultOwner.toBase58(),
            supply: this.supply,
            maxSupply: this.maxSupply,
            state: this.state,
        };
    }
}
exports.SellingResourceAccountData = SellingResourceAccountData;
const sellingResourceAccountDataStruct = new beet.BeetStruct([
    ['accountDiscriminator', beet.fixedSizeArray(beet.u8, 8)],
    ['store', beetSolana.publicKey],
    ['owner', beetSolana.publicKey],
    ['resource', beetSolana.publicKey],
    ['vault', beetSolana.publicKey],
    ['vaultOwner', beetSolana.publicKey],
    ['supply', beet.u64],
    ['maxSupply', beet.coption(beet.u64)],
    ['state', beet.u8],
], SellingResourceAccountData.fromArgs, 'SellingResourceAccountData');
//# sourceMappingURL=SellingResource.js.map