/// <reference types="node" />
import * as web3 from '@solana/web3.js';
export declare type StoreAccountDataArgs = {
    admin: web3.PublicKey;
    name: string;
    description: string;
};
export declare class StoreAccountData {
    readonly admin: web3.PublicKey;
    readonly name: string;
    readonly description: string;
    private constructor();
    static get byteSize(): number;
    static getMinimumBalanceForRentExemption(connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    static hasCorrectByteSize(buf: Buffer, offset?: number): boolean;
    static fromArgs(args: StoreAccountDataArgs): StoreAccountData;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [StoreAccountData, number];
    static deserialize(buf: Buffer, offset?: number): [StoreAccountData, number];
    serialize(): [Buffer, number];
    pretty(): {
        admin: string;
        name: string;
        description: string;
    };
}
