"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreAccountData = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const consts_1 = require("../consts");
const storeAccountDiscriminator = [130, 48, 247, 244, 182, 191, 30, 26];
class StoreAccountData {
    constructor(admin, name, description) {
        this.admin = admin;
        this.name = name;
        this.description = description;
    }
    static get byteSize() {
        return storeAccountDataStruct.byteSize;
    }
    static getMinimumBalanceForRentExemption(connection, commitment) {
        return __awaiter(this, void 0, void 0, function* () {
            return connection.getMinimumBalanceForRentExemption(StoreAccountData.byteSize, commitment);
        });
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === StoreAccountData.byteSize;
    }
    static fromArgs(args) {
        return new StoreAccountData(args.admin, args.name, args.description);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return StoreAccountData.deserialize(accountInfo.data, offset);
    }
    static deserialize(buf, offset = 0) {
        return storeAccountDataStruct.deserialize(buf, offset);
    }
    serialize() {
        return storeAccountDataStruct.serialize(Object.assign({ accountDiscriminator: storeAccountDiscriminator }, this));
    }
    pretty() {
        return {
            admin: this.admin.toBase58(),
            name: this.name,
            description: this.description,
        };
    }
}
exports.StoreAccountData = StoreAccountData;
const storeAccountDataStruct = new beet.BeetStruct([
    ['accountDiscriminator', beet.fixedSizeArray(beet.u8, 8)],
    ['admin', beetSolana.publicKey],
    ['name', beet.fixedSizeUtf8String(consts_1.NAME_MAX_LEN)],
    ['description', beet.fixedSizeUtf8String(consts_1.DESCRIPTION_MAX_LEN)],
], StoreAccountData.fromArgs, 'StoreAccountData');
//# sourceMappingURL=Store.js.map