"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeHistoryAccountData = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const tradeHistoryAccountDiscriminator = [190, 117, 218, 114, 66, 112, 56, 41];
class TradeHistoryAccountData {
    constructor(market, wallet, alreadyBought) {
        this.market = market;
        this.wallet = wallet;
        this.alreadyBought = alreadyBought;
    }
    static get byteSize() {
        return tradeHistoryAccountDataStruct.byteSize;
    }
    static getMinimumBalanceForRentExemption(connection, commitment) {
        return __awaiter(this, void 0, void 0, function* () {
            return connection.getMinimumBalanceForRentExemption(TradeHistoryAccountData.byteSize, commitment);
        });
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === TradeHistoryAccountData.byteSize;
    }
    static fromArgs(args) {
        return new TradeHistoryAccountData(args.market, args.wallet, args.alreadyBought);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return TradeHistoryAccountData.deserialize(accountInfo.data, offset);
    }
    static deserialize(buf, offset = 0) {
        return tradeHistoryAccountDataStruct.deserialize(buf, offset);
    }
    serialize() {
        return tradeHistoryAccountDataStruct.serialize(Object.assign({ accountDiscriminator: tradeHistoryAccountDiscriminator }, this));
    }
    pretty() {
        return {
            market: this.market.toBase58(),
            wallet: this.wallet.toBase58(),
            alreadyBought: this.alreadyBought,
        };
    }
}
exports.TradeHistoryAccountData = TradeHistoryAccountData;
const tradeHistoryAccountDataStruct = new beet.BeetStruct([
    ['accountDiscriminator', beet.fixedSizeArray(beet.u8, 8)],
    ['market', beetSolana.publicKey],
    ['wallet', beetSolana.publicKey],
    ['alreadyBought', beet.u64],
], TradeHistoryAccountData.fromArgs, 'TradeHistoryAccountData');
//# sourceMappingURL=TradeHistory.js.map