"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorFromName = exports.errorFromCode = exports.SupplyIsGtThanMaxSupplyError = exports.MathOverflowError = exports.UserReachBuyLimitError = exports.MarketIsEndedError = exports.MarketIsNotStartedError = exports.IncorrectOwnerError = exports.EndDateIsEarlierThanBeginDateError = exports.StartDateIsInPastError = exports.PiecesInOneWalletIsTooMuchError = exports.PublicKeyMismatchError = exports.SellingResourceOwnerInvalidError = exports.DerivedKeyInvalidError = exports.SupplyIsNotProvidedError = exports.SupplyIsGtThanAvailableError = exports.DescriptionIsTooLongError = exports.NameIsTooLongError = exports.StringIsTooLongError = exports.NoValidSignerPresentError = void 0;
const createErrorFromCodeLookup = new Map();
const createErrorFromNameLookup = new Map();
class NoValidSignerPresentError extends Error {
    constructor() {
        super('No valid signer present');
        this.code = 0x1770;
        this.name = 'NoValidSignerPresent';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NoValidSignerPresentError);
        }
    }
}
exports.NoValidSignerPresentError = NoValidSignerPresentError;
createErrorFromCodeLookup.set(0x1770, () => new NoValidSignerPresentError());
createErrorFromNameLookup.set('NoValidSignerPresent', () => new NoValidSignerPresentError());
class StringIsTooLongError extends Error {
    constructor() {
        super('Some string variable is longer than allowed');
        this.code = 0x1771;
        this.name = 'StringIsTooLong';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, StringIsTooLongError);
        }
    }
}
exports.StringIsTooLongError = StringIsTooLongError;
createErrorFromCodeLookup.set(0x1771, () => new StringIsTooLongError());
createErrorFromNameLookup.set('StringIsTooLong', () => new StringIsTooLongError());
class NameIsTooLongError extends Error {
    constructor() {
        super('Name string variable is longer than allowed');
        this.code = 0x1772;
        this.name = 'NameIsTooLong';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NameIsTooLongError);
        }
    }
}
exports.NameIsTooLongError = NameIsTooLongError;
createErrorFromCodeLookup.set(0x1772, () => new NameIsTooLongError());
createErrorFromNameLookup.set('NameIsTooLong', () => new NameIsTooLongError());
class DescriptionIsTooLongError extends Error {
    constructor() {
        super('Description string variable is longer than allowed');
        this.code = 0x1773;
        this.name = 'DescriptionIsTooLong';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, DescriptionIsTooLongError);
        }
    }
}
exports.DescriptionIsTooLongError = DescriptionIsTooLongError;
createErrorFromCodeLookup.set(0x1773, () => new DescriptionIsTooLongError());
createErrorFromNameLookup.set('DescriptionIsTooLong', () => new DescriptionIsTooLongError());
class SupplyIsGtThanAvailableError extends Error {
    constructor() {
        super('Provided supply is gt than available');
        this.code = 0x1774;
        this.name = 'SupplyIsGtThanAvailable';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, SupplyIsGtThanAvailableError);
        }
    }
}
exports.SupplyIsGtThanAvailableError = SupplyIsGtThanAvailableError;
createErrorFromCodeLookup.set(0x1774, () => new SupplyIsGtThanAvailableError());
createErrorFromNameLookup.set('SupplyIsGtThanAvailable', () => new SupplyIsGtThanAvailableError());
class SupplyIsNotProvidedError extends Error {
    constructor() {
        super('Supply is not provided');
        this.code = 0x1775;
        this.name = 'SupplyIsNotProvided';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, SupplyIsNotProvidedError);
        }
    }
}
exports.SupplyIsNotProvidedError = SupplyIsNotProvidedError;
createErrorFromCodeLookup.set(0x1775, () => new SupplyIsNotProvidedError());
createErrorFromNameLookup.set('SupplyIsNotProvided', () => new SupplyIsNotProvidedError());
class DerivedKeyInvalidError extends Error {
    constructor() {
        super('Derived key invalid');
        this.code = 0x1776;
        this.name = 'DerivedKeyInvalid';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, DerivedKeyInvalidError);
        }
    }
}
exports.DerivedKeyInvalidError = DerivedKeyInvalidError;
createErrorFromCodeLookup.set(0x1776, () => new DerivedKeyInvalidError());
createErrorFromNameLookup.set('DerivedKeyInvalid', () => new DerivedKeyInvalidError());
class SellingResourceOwnerInvalidError extends Error {
    constructor() {
        super('Invalid selling resource owner provided');
        this.code = 0x1777;
        this.name = 'SellingResourceOwnerInvalid';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, SellingResourceOwnerInvalidError);
        }
    }
}
exports.SellingResourceOwnerInvalidError = SellingResourceOwnerInvalidError;
createErrorFromCodeLookup.set(0x1777, () => new SellingResourceOwnerInvalidError());
createErrorFromNameLookup.set('SellingResourceOwnerInvalid', () => new SellingResourceOwnerInvalidError());
class PublicKeyMismatchError extends Error {
    constructor() {
        super('PublicKeyMismatch');
        this.code = 0x1778;
        this.name = 'PublicKeyMismatch';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, PublicKeyMismatchError);
        }
    }
}
exports.PublicKeyMismatchError = PublicKeyMismatchError;
createErrorFromCodeLookup.set(0x1778, () => new PublicKeyMismatchError());
createErrorFromNameLookup.set('PublicKeyMismatch', () => new PublicKeyMismatchError());
class PiecesInOneWalletIsTooMuchError extends Error {
    constructor() {
        super('Pieces in one wallet cannot be greater than Max Supply value');
        this.code = 0x1779;
        this.name = 'PiecesInOneWalletIsTooMuch';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, PiecesInOneWalletIsTooMuchError);
        }
    }
}
exports.PiecesInOneWalletIsTooMuchError = PiecesInOneWalletIsTooMuchError;
createErrorFromCodeLookup.set(0x1779, () => new PiecesInOneWalletIsTooMuchError());
createErrorFromNameLookup.set('PiecesInOneWalletIsTooMuch', () => new PiecesInOneWalletIsTooMuchError());
class StartDateIsInPastError extends Error {
    constructor() {
        super('StartDate cannot be in the past');
        this.code = 0x177a;
        this.name = 'StartDateIsInPast';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, StartDateIsInPastError);
        }
    }
}
exports.StartDateIsInPastError = StartDateIsInPastError;
createErrorFromCodeLookup.set(0x177a, () => new StartDateIsInPastError());
createErrorFromNameLookup.set('StartDateIsInPast', () => new StartDateIsInPastError());
class EndDateIsEarlierThanBeginDateError extends Error {
    constructor() {
        super('EndDate should not be earlier than StartDate');
        this.code = 0x177b;
        this.name = 'EndDateIsEarlierThanBeginDate';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, EndDateIsEarlierThanBeginDateError);
        }
    }
}
exports.EndDateIsEarlierThanBeginDateError = EndDateIsEarlierThanBeginDateError;
createErrorFromCodeLookup.set(0x177b, () => new EndDateIsEarlierThanBeginDateError());
createErrorFromNameLookup.set('EndDateIsEarlierThanBeginDate', () => new EndDateIsEarlierThanBeginDateError());
class IncorrectOwnerError extends Error {
    constructor() {
        super('Incorrect account owner');
        this.code = 0x177c;
        this.name = 'IncorrectOwner';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, IncorrectOwnerError);
        }
    }
}
exports.IncorrectOwnerError = IncorrectOwnerError;
createErrorFromCodeLookup.set(0x177c, () => new IncorrectOwnerError());
createErrorFromNameLookup.set('IncorrectOwner', () => new IncorrectOwnerError());
class MarketIsNotStartedError extends Error {
    constructor() {
        super('Market is not started');
        this.code = 0x177d;
        this.name = 'MarketIsNotStarted';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MarketIsNotStartedError);
        }
    }
}
exports.MarketIsNotStartedError = MarketIsNotStartedError;
createErrorFromCodeLookup.set(0x177d, () => new MarketIsNotStartedError());
createErrorFromNameLookup.set('MarketIsNotStarted', () => new MarketIsNotStartedError());
class MarketIsEndedError extends Error {
    constructor() {
        super('Market is ended');
        this.code = 0x177e;
        this.name = 'MarketIsEnded';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MarketIsEndedError);
        }
    }
}
exports.MarketIsEndedError = MarketIsEndedError;
createErrorFromCodeLookup.set(0x177e, () => new MarketIsEndedError());
createErrorFromNameLookup.set('MarketIsEnded', () => new MarketIsEndedError());
class UserReachBuyLimitError extends Error {
    constructor() {
        super('User reach buy limit');
        this.code = 0x177f;
        this.name = 'UserReachBuyLimit';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, UserReachBuyLimitError);
        }
    }
}
exports.UserReachBuyLimitError = UserReachBuyLimitError;
createErrorFromCodeLookup.set(0x177f, () => new UserReachBuyLimitError());
createErrorFromNameLookup.set('UserReachBuyLimit', () => new UserReachBuyLimitError());
class MathOverflowError extends Error {
    constructor() {
        super('Math overflow');
        this.code = 0x1780;
        this.name = 'MathOverflow';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MathOverflowError);
        }
    }
}
exports.MathOverflowError = MathOverflowError;
createErrorFromCodeLookup.set(0x1780, () => new MathOverflowError());
createErrorFromNameLookup.set('MathOverflow', () => new MathOverflowError());
class SupplyIsGtThanMaxSupplyError extends Error {
    constructor() {
        super('Supply is gt than max supply');
        this.code = 0x1781;
        this.name = 'SupplyIsGtThanMaxSupply';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, SupplyIsGtThanMaxSupplyError);
        }
    }
}
exports.SupplyIsGtThanMaxSupplyError = SupplyIsGtThanMaxSupplyError;
createErrorFromCodeLookup.set(0x1781, () => new SupplyIsGtThanMaxSupplyError());
createErrorFromNameLookup.set('SupplyIsGtThanMaxSupply', () => new SupplyIsGtThanMaxSupplyError());
function errorFromCode(code) {
    const createError = createErrorFromCodeLookup.get(code);
    return createError != null ? createError() : null;
}
exports.errorFromCode = errorFromCode;
function errorFromName(name) {
    const createError = createErrorFromNameLookup.get(name);
    return createError != null ? createError() : null;
}
exports.errorFromName = errorFromName;
//# sourceMappingURL=index.js.map