"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMetadata = void 0;
const amman_1 = require("@metaplex-foundation/amman");
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
function createMetadata({ transactionHandler, publicKey, editionMint, metadataData, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const metadata = yield mpl_token_metadata_1.Metadata.getPDA(editionMint);
        const createMetadataTx = new mpl_token_metadata_1.CreateMetadata({ feePayer: publicKey }, {
            metadata,
            metadataData,
            updateAuthority: publicKey,
            mint: editionMint,
            mintAuthority: publicKey,
        });
        const createTxDetails = yield transactionHandler.sendAndConfirmTransaction(createMetadataTx, [], amman_1.defaultSendOptions);
        return { metadata, createTxDetails };
    });
}
exports.createMetadata = createMetadata;
//# sourceMappingURL=create-metadata.js.map