"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createInitSellingResourceTransaction = void 0;
const web3_js_1 = require("@solana/web3.js");
const mpl_membership_token_1 = require("../../src/mpl-membership-token");
const createInitSellingResourceTransaction = ({ payer, connection, store, resourceMint, masterEdition, vault, owner, resourceToken, masterEditionBump, vaultOwnerBump, maxSupply, }) => __awaiter(void 0, void 0, void 0, function* () {
    const sellingResource = web3_js_1.Keypair.generate();
    const instruction = (0, mpl_membership_token_1.createInitSellingResourceInstruction)({
        store: store.publicKey,
        admin: payer.publicKey,
        sellingResource: sellingResource.publicKey,
        sellingResourceOwner: payer.publicKey,
        masterEdition,
        resourceMint,
        resourceToken,
        vault: vault.publicKey,
        owner,
    }, {
        masterEditionBump,
        vaultOwnerBump,
        maxSupply,
    });
    const initSellingResourceTx = new web3_js_1.Transaction();
    initSellingResourceTx.add(instruction);
    initSellingResourceTx.recentBlockhash = (yield connection.getRecentBlockhash()).blockhash;
    initSellingResourceTx.feePayer = payer.publicKey;
    initSellingResourceTx.partialSign(sellingResource, vault);
    return {
        sellingResource,
        initSellingResourceTx,
    };
});
exports.createInitSellingResourceTransaction = createInitSellingResourceTransaction;
//# sourceMappingURL=init-selling-resouce.js.map